// Code generated by mockery v2.14.0. DO NOT EDIT.

package mocks

import (
	models "kuber-crud/models"

	mock "github.com/stretchr/testify/mock"
)

// RedisRepo is an autogenerated mock type for the RedisRepo type
type RedisRepo struct {
	mock.Mock
}

// Create provides a mock function with given fields: value, group
func (_m *RedisRepo) Create(value *models.Node, group string) error {
	ret := _m.Called(value, group)

	var r0 error
	if rf, ok := ret.Get(0).(func(*models.Node, string) error); ok {
		r0 = rf(value, group)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Get provides a mock function with given fields: group, _type, tier
func (_m *RedisRepo) Get(group string, _type string, tier string) (*models.Node, error) {
	ret := _m.Called(group, _type, tier)

	var r0 *models.Node
	if rf, ok := ret.Get(0).(func(string, string, string) *models.Node); ok {
		r0 = rf(group, _type, tier)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Node)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string, string, string) error); ok {
		r1 = rf(group, _type, tier)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// List provides a mock function with given fields: group, _type, tier
func (_m *RedisRepo) List(group string, _type string, tier string) (*[]models.Node, error) {
	ret := _m.Called(group, _type, tier)

	var r0 *[]models.Node
	if rf, ok := ret.Get(0).(func(string, string, string) *[]models.Node); ok {
		r0 = rf(group, _type, tier)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*[]models.Node)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string, string, string) error); ok {
		r1 = rf(group, _type, tier)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Remove provides a mock function with given fields: group, _type, tier
func (_m *RedisRepo) Remove(group string, _type string, tier string) error {
	ret := _m.Called(group, _type, tier)

	var r0 error
	if rf, ok := ret.Get(0).(func(string, string, string) error); ok {
		r0 = rf(group, _type, tier)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Update provides a mock function with given fields: value, group
func (_m *RedisRepo) Update(value *models.Node, group string) error {
	ret := _m.Called(value, group)

	var r0 error
	if rf, ok := ret.Get(0).(func(*models.Node, string) error); ok {
		r0 = rf(value, group)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewRedisRepo interface {
	mock.TestingT
	Cleanup(func())
}

// NewRedisRepo creates a new instance of RedisRepo. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewRedisRepo(t mockConstructorTestingTNewRedisRepo) *RedisRepo {
	mock := &RedisRepo{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
